"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ParagraphStyle = void 0;
const ParagraphProperties_1 = require("./ParagraphProperties");
const Style_1 = require("./Style");
const StyleFamily_1 = require("./StyleFamily");
const TabStopType_1 = require("./TabStopType");
const TextProperties_1 = require("./TextProperties");
class ParagraphStyle extends Style_1.Style {
    constructor(displayName = Style_1.Style.UNNAMED) {
        super(displayName, StyleFamily_1.StyleFamily.Paragraph);
        this.paragraphProperties = new ParagraphProperties_1.ParagraphProperties();
        this.textProperties = new TextProperties_1.TextProperties();
    }
    // paragraph properties
    /** @inheritdoc */
    setBackgroundColor(color) {
        this.paragraphProperties.setBackgroundColor(color);
        return this;
    }
    /** @inheritdoc */
    getBackgroundColor() {
        return this.paragraphProperties.getBackgroundColor();
    }
    /** @inheritdoc */
    setBorder(width, style, color) {
        this.paragraphProperties.setBorder(width, style, color);
        return this;
    }
    /** @inheritdoc */
    removeBorder() {
        this.paragraphProperties.removeBorder();
        return this;
    }
    /** @inheritdoc */
    setBorderBottom(width, style, color) {
        this.paragraphProperties.setBorderBottom(width, style, color);
        return this;
    }
    /** @inheritdoc */
    getBorderBottom() {
        return this.paragraphProperties.getBorderBottom();
    }
    /** @inheritdoc */
    removeBorderBottom() {
        this.paragraphProperties.removeBorderBottom();
        return this;
    }
    /** @inheritdoc */
    setBorderLeft(width, style, color) {
        this.paragraphProperties.setBorderLeft(width, style, color);
        return this;
    }
    /** @inheritdoc */
    getBorderLeft() {
        return this.paragraphProperties.getBorderLeft();
    }
    /** @inheritdoc */
    removeBorderLeft() {
        this.paragraphProperties.removeBorderLeft();
        return this;
    }
    /** @inheritdoc */
    setBorderRight(width, style, color) {
        this.paragraphProperties.setBorderRight(width, style, color);
        return this;
    }
    /** @inheritdoc */
    getBorderRight() {
        return this.paragraphProperties.getBorderRight();
    }
    /** @inheritdoc */
    removeBorderRight() {
        this.paragraphProperties.removeBorderRight();
        return this;
    }
    /** @inheritdoc */
    setBorderTop(width, style, color) {
        this.paragraphProperties.setBorderTop(width, style, color);
        return this;
    }
    /** @inheritdoc */
    getBorderTop() {
        return this.paragraphProperties.getBorderTop();
    }
    /** @inheritdoc */
    removeBorderTop() {
        this.paragraphProperties.removeBorderTop();
        return this;
    }
    /** @inheritdoc */
    setHorizontalAlignment(horizontalAlignment) {
        this.paragraphProperties.setHorizontalAlignment(horizontalAlignment);
        return this;
    }
    /** @inheritdoc */
    getHorizontalAlignment() {
        return this.paragraphProperties.getHorizontalAlignment();
    }
    /** @inheritdoc */
    setHorizontalAlignmentLastLine(horizontalAlignment) {
        this.paragraphProperties.setHorizontalAlignmentLastLine(horizontalAlignment);
        return this;
    }
    /** @inheritdoc */
    getHorizontalAlignmentLastLine() {
        return this.paragraphProperties.getHorizontalAlignmentLastLine();
    }
    /** @inheritdoc */
    setKeepTogether(keepTogether = true) {
        this.paragraphProperties.setKeepTogether(keepTogether);
        return this;
    }
    /** @inheritdoc */
    getKeepTogether() {
        return this.paragraphProperties.getKeepTogether();
    }
    /** @inheritdoc */
    setKeepWithNext(keepWithNext = true) {
        this.paragraphProperties.setKeepWithNext(keepWithNext);
        return this;
    }
    /** @inheritdoc */
    getKeepWithNext() {
        return this.paragraphProperties.getKeepWithNext();
    }
    /** @inheritdoc */
    setLineHeight(lineHeight) {
        this.paragraphProperties.setLineHeight(lineHeight);
        return this;
    }
    /** @inheritdoc */
    getLineHeight() {
        return this.paragraphProperties.getLineHeight();
    }
    /** @inheritdoc */
    setLineHeightAtLeast(minimumLineHeight) {
        this.paragraphProperties.setLineHeightAtLeast(minimumLineHeight);
        return this;
    }
    /** @inheritdoc */
    getLineHeightAtLeast() {
        return this.paragraphProperties.getLineHeightAtLeast();
    }
    /** @inheritdoc */
    setLineSpacing(lineSpacing) {
        this.paragraphProperties.setLineSpacing(lineSpacing);
        return this;
    }
    /** @inheritdoc */
    getLineSpacing() {
        return this.paragraphProperties.getLineSpacing();
    }
    /** @inheritdoc */
    setMarginBottom(margin) {
        this.paragraphProperties.setMarginBottom(margin);
        return this;
    }
    /** @inheritdoc */
    getMarginBottom() {
        return this.paragraphProperties.getMarginBottom();
    }
    /** @inheritdoc */
    setMarginLeft(margin) {
        this.paragraphProperties.setMarginLeft(margin);
        return this;
    }
    /** @inheritdoc */
    getMarginLeft() {
        return this.paragraphProperties.getMarginLeft();
    }
    /** @inheritdoc */
    setMarginRight(margin) {
        this.paragraphProperties.setMarginRight(margin);
        return this;
    }
    /** @inheritdoc */
    getMarginRight() {
        return this.paragraphProperties.getMarginRight();
    }
    /** @inheritdoc */
    setMarginTop(margin) {
        this.paragraphProperties.setMarginTop(margin);
        return this;
    }
    /** @inheritdoc */
    getMarginTop() {
        return this.paragraphProperties.getMarginTop();
    }
    /** @inheritdoc */
    setMargin(marginLeft, marginRight, marginTop, marginBottom) {
        this.paragraphProperties.setMargin(marginLeft, marginRight, marginTop, marginBottom);
        return this;
    }
    /** @inheritdoc */
    setOrphans(orphans) {
        this.paragraphProperties.setOrphans(orphans);
        return this;
    }
    /** @inheritdoc */
    getOrphans() {
        return this.paragraphProperties.getOrphans();
    }
    /** @inheritdoc */
    setPaddingBottom(padding) {
        this.paragraphProperties.setPaddingBottom(padding);
        return this;
    }
    /** @inheritdoc */
    getPaddingBottom() {
        return this.paragraphProperties.getPaddingBottom();
    }
    /** @inheritdoc */
    setPaddingLeft(padding) {
        this.paragraphProperties.setPaddingLeft(padding);
        return this;
    }
    /** @inheritdoc */
    getPaddingLeft() {
        return this.paragraphProperties.getPaddingLeft();
    }
    /** @inheritdoc */
    setPaddingRight(padding) {
        this.paragraphProperties.setPaddingRight(padding);
        return this;
    }
    /** @inheritdoc */
    getPaddingRight() {
        return this.paragraphProperties.getPaddingRight();
    }
    /** @inheritdoc */
    setPaddingTop(padding) {
        this.paragraphProperties.setPaddingTop(padding);
        return this;
    }
    /** @inheritdoc */
    getPaddingTop() {
        return this.paragraphProperties.getPaddingTop();
    }
    /** @inheritdoc */
    setPadding(paddingLeft, paddingRight, paddingTop, paddingBottom) {
        this.paragraphProperties.setPadding(paddingLeft, paddingRight, paddingTop, paddingBottom);
        return this;
    }
    /** @inheritdoc */
    setPageBreak(pageBreak) {
        this.paragraphProperties.setPageBreak(pageBreak);
        return this;
    }
    /** @inheritdoc */
    getPageBreak() {
        return this.paragraphProperties.getPageBreak();
    }
    /** @inheritdoc */
    setTextIndent(textIndent) {
        this.paragraphProperties.setTextIndent(textIndent);
        return this;
    }
    /** @inheritdoc */
    getTextIndent() {
        return this.paragraphProperties.getTextIndent();
    }
    /** @inheritdoc */
    setVerticalAlignment(verticalAlignment) {
        this.paragraphProperties.setVerticalAlignment(verticalAlignment);
        return this;
    }
    /** @inheritdoc */
    getVerticalAlignment() {
        return this.paragraphProperties.getVerticalAlignment();
    }
    /** @inheritdoc */
    setWidows(widows) {
        this.paragraphProperties.setWidows(widows);
        return this;
    }
    /** @inheritdoc */
    getWidows() {
        return this.paragraphProperties.getWidows();
    }
    addTabStop(arg1, type = TabStopType_1.TabStopType.Left) {
        return this.paragraphProperties.addTabStop(arg1, type);
    }
    /** @inheritdoc */
    getTabStops() {
        return this.paragraphProperties.getTabStops();
    }
    /** @inheritdoc */
    clearTabStops() {
        this.paragraphProperties.clearTabStops();
        return this;
    }
    // text properties
    /** @inheritDoc */
    setColor(color) {
        this.textProperties.setColor(color);
        return this;
    }
    /** @inheritDoc */
    getColor() {
        return this.textProperties.getColor();
    }
    /** @inheritDoc */
    setFontName(name) {
        this.textProperties.setFontName(name);
        return this;
    }
    /** @inheritDoc */
    getFontName() {
        return this.textProperties.getFontName();
    }
    /** @inheritDoc */
    setFontSize(size) {
        this.textProperties.setFontSize(size);
        return this;
    }
    /** @inheritDoc */
    getFontSize() {
        return this.textProperties.getFontSize();
    }
    /** @inheritDoc */
    setTextTransformation(transformation) {
        this.textProperties.setTextTransformation(transformation);
        return this;
    }
    /** @inheritDoc */
    setFontVariant(fontVariant) {
        this.textProperties.setFontVariant(fontVariant);
        return this;
    }
    /** @inheritDoc */
    getFontVariant() {
        return this.textProperties.getFontVariant();
    }
    /** @inheritDoc */
    getTextTransformation() {
        return this.textProperties.getTextTransformation();
    }
    /** @inheritDoc */
    setTypeface(typeface) {
        this.textProperties.setTypeface(typeface);
        return this;
    }
    /** @inheritDoc */
    getTypeface() {
        return this.textProperties.getTypeface();
    }
}
exports.ParagraphStyle = ParagraphStyle;
