import { OdfElement } from '../OdfElement';
/**
 * This class represents text in a paragraph.
 *
 * @since 0.3.0
 * @private
 */
export declare class OdfTextElement extends OdfElement {
    private text;
    /**
     * Creates a text
     *
     * @param {string} text The text content
     * @since 0.3.0
     */
    constructor(text: string);
    /**
     * Sets the new text content.
     *
     * @param {string} text The new text content
     * @since 0.3.0
     */
    setText(text: string): void;
    /**
     * Returns the text content.
     *
     * @returns {string} The text content
     * @since 0.3.0
     */
    getText(): string;
}
