"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isPositiveLength = void 0;
/**
 * The `isPositiveLength` method returns whether the given value is a positive number.
 *
 * ([0-9]*[1-9][0-9]*(\.[0-9]*)?|0+\.[0-9]*[1-9][0-9]*|\.[0-9]*[1-9][0-9]*)((cm)|(mm)|(in)|(pt)|(pc)|(px))
 *
 * @param {any} value The value that is to be checked
 * @returns {boolean} `true` if the given value is a positive number, `false` otherwise
 * @private
 */
// eslint-disable-next-line @typescript-eslint/no-explicit-any
function isPositiveLength(value) {
    return typeof value === 'number' && value >= 0;
}
exports.isPositiveLength = isPositiveLength;
